/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
	"time"
)

// checks if the MediaFile type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MediaFile{}

// MediaFile struct for MediaFile
type MediaFile struct {
	Id string `json:"id"`
	GatewayId string `json:"gateway_id"`
	MimeType string `json:"mime_type"`
	StorageId string `json:"storage_id"`
	MessengerId *string `json:"messenger_id,omitempty"`
	// Byte size
	Size int32 `json:"size"`
	Width *int32 `json:"width,omitempty"`
	Height *int32 `json:"height,omitempty"`
	Url string `json:"url"`
	CreatedAt time.Time `json:"created_at"`
}

// NewMediaFile instantiates a new MediaFile object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMediaFile(id string, gatewayId string, mimeType string, storageId string, size int32, url string, createdAt time.Time) *MediaFile {
	this := MediaFile{}
	this.Id = id
	this.GatewayId = gatewayId
	this.MimeType = mimeType
	this.StorageId = storageId
	this.Size = size
	this.Url = url
	this.CreatedAt = createdAt
	return &this
}

// NewMediaFileWithDefaults instantiates a new MediaFile object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMediaFileWithDefaults() *MediaFile {
	this := MediaFile{}
	return &this
}

// GetId returns the Id field value
func (o *MediaFile) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *MediaFile) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *MediaFile) SetId(v string) {
	o.Id = v
}

// GetGatewayId returns the GatewayId field value
func (o *MediaFile) GetGatewayId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.GatewayId
}

// GetGatewayIdOk returns a tuple with the GatewayId field value
// and a boolean to check if the value has been set.
func (o *MediaFile) GetGatewayIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.GatewayId, true
}

// SetGatewayId sets field value
func (o *MediaFile) SetGatewayId(v string) {
	o.GatewayId = v
}

// GetMimeType returns the MimeType field value
func (o *MediaFile) GetMimeType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.MimeType
}

// GetMimeTypeOk returns a tuple with the MimeType field value
// and a boolean to check if the value has been set.
func (o *MediaFile) GetMimeTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.MimeType, true
}

// SetMimeType sets field value
func (o *MediaFile) SetMimeType(v string) {
	o.MimeType = v
}

// GetStorageId returns the StorageId field value
func (o *MediaFile) GetStorageId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.StorageId
}

// GetStorageIdOk returns a tuple with the StorageId field value
// and a boolean to check if the value has been set.
func (o *MediaFile) GetStorageIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.StorageId, true
}

// SetStorageId sets field value
func (o *MediaFile) SetStorageId(v string) {
	o.StorageId = v
}

// GetMessengerId returns the MessengerId field value if set, zero value otherwise.
func (o *MediaFile) GetMessengerId() string {
	if o == nil || IsNil(o.MessengerId) {
		var ret string
		return ret
	}
	return *o.MessengerId
}

// GetMessengerIdOk returns a tuple with the MessengerId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MediaFile) GetMessengerIdOk() (*string, bool) {
	if o == nil || IsNil(o.MessengerId) {
		return nil, false
	}
	return o.MessengerId, true
}

// HasMessengerId returns a boolean if a field has been set.
func (o *MediaFile) HasMessengerId() bool {
	if o != nil && !IsNil(o.MessengerId) {
		return true
	}

	return false
}

// SetMessengerId gets a reference to the given string and assigns it to the MessengerId field.
func (o *MediaFile) SetMessengerId(v string) {
	o.MessengerId = &v
}

// GetSize returns the Size field value
func (o *MediaFile) GetSize() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Size
}

// GetSizeOk returns a tuple with the Size field value
// and a boolean to check if the value has been set.
func (o *MediaFile) GetSizeOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Size, true
}

// SetSize sets field value
func (o *MediaFile) SetSize(v int32) {
	o.Size = v
}

// GetWidth returns the Width field value if set, zero value otherwise.
func (o *MediaFile) GetWidth() int32 {
	if o == nil || IsNil(o.Width) {
		var ret int32
		return ret
	}
	return *o.Width
}

// GetWidthOk returns a tuple with the Width field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MediaFile) GetWidthOk() (*int32, bool) {
	if o == nil || IsNil(o.Width) {
		return nil, false
	}
	return o.Width, true
}

// HasWidth returns a boolean if a field has been set.
func (o *MediaFile) HasWidth() bool {
	if o != nil && !IsNil(o.Width) {
		return true
	}

	return false
}

// SetWidth gets a reference to the given int32 and assigns it to the Width field.
func (o *MediaFile) SetWidth(v int32) {
	o.Width = &v
}

// GetHeight returns the Height field value if set, zero value otherwise.
func (o *MediaFile) GetHeight() int32 {
	if o == nil || IsNil(o.Height) {
		var ret int32
		return ret
	}
	return *o.Height
}

// GetHeightOk returns a tuple with the Height field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MediaFile) GetHeightOk() (*int32, bool) {
	if o == nil || IsNil(o.Height) {
		return nil, false
	}
	return o.Height, true
}

// HasHeight returns a boolean if a field has been set.
func (o *MediaFile) HasHeight() bool {
	if o != nil && !IsNil(o.Height) {
		return true
	}

	return false
}

// SetHeight gets a reference to the given int32 and assigns it to the Height field.
func (o *MediaFile) SetHeight(v int32) {
	o.Height = &v
}

// GetUrl returns the Url field value
func (o *MediaFile) GetUrl() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Url
}

// GetUrlOk returns a tuple with the Url field value
// and a boolean to check if the value has been set.
func (o *MediaFile) GetUrlOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Url, true
}

// SetUrl sets field value
func (o *MediaFile) SetUrl(v string) {
	o.Url = v
}

// GetCreatedAt returns the CreatedAt field value
func (o *MediaFile) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *MediaFile) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *MediaFile) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

func (o MediaFile) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MediaFile) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["gateway_id"] = o.GatewayId
	toSerialize["mime_type"] = o.MimeType
	toSerialize["storage_id"] = o.StorageId
	if !IsNil(o.MessengerId) {
		toSerialize["messenger_id"] = o.MessengerId
	}
	toSerialize["size"] = o.Size
	if !IsNil(o.Width) {
		toSerialize["width"] = o.Width
	}
	if !IsNil(o.Height) {
		toSerialize["height"] = o.Height
	}
	toSerialize["url"] = o.Url
	toSerialize["created_at"] = o.CreatedAt
	return toSerialize, nil
}

type NullableMediaFile struct {
	value *MediaFile
	isSet bool
}

func (v NullableMediaFile) Get() *MediaFile {
	return v.value
}

func (v *NullableMediaFile) Set(val *MediaFile) {
	v.value = val
	v.isSet = true
}

func (v NullableMediaFile) IsSet() bool {
	return v.isSet
}

func (v *NullableMediaFile) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMediaFile(val *MediaFile) *NullableMediaFile {
	return &NullableMediaFile{value: val, isSet: true}
}

func (v NullableMediaFile) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMediaFile) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


